;; ***** BEGIN LICENSE BLOCK *****
;; Roadsend PHP Compiler Runtime Libraries
;; Copyright (C) 2007 Roadsend, Inc.
;;
;; This program is free software; you can redistribute it and/or
;; modify it under the terms of the GNU Lesser General Public License
;; as published by the Free Software Foundation; either version 2.1
;; of the License, or (at your option) any later version.
;; 
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU Lesser General Public License for more details.
;; 
;; You should have received a copy of the GNU Lesser General Public License
;; along with this program; if not, write to the Free Software
;; Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
;; ***** END LICENSE BLOCK *****

(module odbc-c-bindings
 (extern
  (include "windows-odbc.h")
  (include "sqlext.h")
  (include "odbc-utils.h")

  ; utils
  (macro get-odbc-errormsg::obj (SQLHANDLE SQLSMALLINT) "get_odbc_errormsg")

  (type result-val
	(struct (name::string "name")
		(coltype::SQLINTEGER "coltype")
		(val::string "val")
		(len::SQLINTEGER "len"))
	"struct result_val")
  
  ; odbc api
  (macro SQLAllocConnect::SQLRETURN (SQLHENV SQLHDBC*) "SQLAllocConnect")
  (macro SQLAllocEnv::SQLRETURN (SQLHENV*) "SQLAllocEnv")
  (macro SQLAllocHandle::SQLRETURN (SQLSMALLINT SQLHANDLE SQLHANDLE*) "SQLAllocHandle")
  (macro SQLAllocStmt::SQLRETURN (SQLHDBC SQLHSTMT*) "SQLAllocStmt")
  (macro SQLBindCol::SQLRETURN (SQLHSTMT SQLUSMALLINT SQLSMALLINT SQLPOINTER SQLINTEGER SQLINTEGER*) "SQLBindCol")
  (macro SQLBindParam::SQLRETURN (SQLHSTMT SQLUSMALLINT SQLSMALLINT SQLSMALLINT SQLUINTEGER SQLSMALLINT SQLPOINTER SQLINTEGER*) "SQLBindParam")
  (macro SQLCancel::SQLRETURN (SQLHSTMT) "SQLCancel")
  (macro SQLCloseCursor::SQLRETURN (SQLHSTMT) "SQLCloseCursor")
  (macro SQLColAttribute::SQLRETURN (SQLHSTMT SQLUSMALLINT SQLUSMALLINT SQLPOINTER SQLSMALLINT SQLSMALLINT* SQLPOINTER) "SQLColAttribute")
   (macro SQLColumns::SQLRETURN (SQLHSTMT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT) "SQLColumns")
   (macro SQLConnect::SQLRETURN (SQLHDBC SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT) "SQLConnect")
   (macro SQLCopyDesc::SQLRETURN (SQLHDESC SQLHDESC) "SQLCopyDesc")
   (macro SQLDataSources::SQLRETURN (SQLHENV SQLUSMALLINT SQLCHAR* SQLSMALLINT SQLSMALLINT* SQLCHAR* SQLSMALLINT SQLSMALLINT*) "SQLDataSources")
   (macro SQLDescribeCol::SQLRETURN (SQLHSTMT SQLUSMALLINT SQLCHAR* SQLSMALLINT SQLSMALLINT* SQLSMALLINT* SQLUINTEGER* SQLSMALLINT* SQLSMALLINT*) "SQLDescribeCol")
   (macro SQLDisconnect::SQLRETURN (SQLHDBC) "SQLDisconnect")
   (macro SQLEndTran::SQLRETURN (SQLSMALLINT SQLHANDLE SQLSMALLINT) "SQLEndTran")
   (macro SQLError::SQLRETURN (SQLHENV SQLHDBC SQLHSTMT SQLCHAR* SQLINTEGER* SQLCHAR* SQLSMALLINT SQLSMALLINT*) "SQLError")
   (macro SQLExecDirect::SQLRETURN (SQLHSTMT SQLCHAR* SQLINTEGER) "SQLExecDirect")
   (macro SQLExecute::SQLRETURN (SQLHSTMT) "SQLExecute")
   (macro SQLFetch::SQLRETURN (SQLHSTMT) "SQLFetch")
   (macro SQLFetchScroll::SQLRETURN (SQLHSTMT SQLSMALLINT SQLROWOFFSET) "SQLFetchScroll")
   (macro SQLFreeConnect::SQLRETURN (SQLHDBC) "SQLFreeConnect")
   (macro SQLFreeEnv::SQLRETURN (SQLHENV) "SQLFreeEnv")
   (macro SQLFreeHandle::SQLRETURN (SQLSMALLINT SQLHANDLE) "SQLFreeHandle")
   (macro SQLFreeStmt::SQLRETURN (SQLHSTMT SQLUSMALLINT) "SQLFreeStmt")
   (macro SQLGetConnectAttr::SQLRETURN (SQLHDBC SQLINTEGER SQLPOINTER SQLINTEGER SQLINTEGER*) "SQLGetConnectAttr")
   (macro SQLGetConnectOption::SQLRETURN (SQLHDBC SQLUSMALLINT SQLPOINTER) "SQLGetConnectOption")
   (macro SQLGetCursorName::SQLRETURN (SQLHSTMT SQLCHAR* SQLSMALLINT SQLSMALLINT*) "SQLGetCursorName")
   (macro SQLGetData::SQLRETURN (SQLHSTMT SQLUSMALLINT SQLSMALLINT SQLPOINTER SQLINTEGER SQLINTEGER*) "SQLGetData")
   (macro SQLGetDescField::SQLRETURN (SQLHDESC SQLSMALLINT SQLSMALLINT SQLPOINTER SQLINTEGER SQLINTEGER*) "SQLGetDescField")
   (macro SQLGetDescRec::SQLRETURN (SQLHDESC SQLSMALLINT SQLCHAR* SQLSMALLINT SQLSMALLINT* SQLSMALLINT* SQLSMALLINT* SQLINTEGER* SQLSMALLINT* SQLSMALLINT* SQLSMALLINT*) "SQLGetDescRec")
   (macro SQLGetDiagField::SQLRETURN (SQLSMALLINT SQLHANDLE SQLSMALLINT SQLSMALLINT SQLPOINTER SQLSMALLINT SQLSMALLINT*) "SQLGetDiagField")
   (macro SQLGetDiagRec::SQLRETURN (SQLSMALLINT SQLHANDLE SQLSMALLINT SQLCHAR* SQLINTEGER* SQLCHAR* SQLSMALLINT SQLSMALLINT*) "SQLGetDiagRec")
   (macro SQLGetEnvAttr::SQLRETURN (SQLHENV SQLINTEGER SQLPOINTER SQLINTEGER SQLINTEGER*) "SQLGetEnvAttr")
   (macro SQLGetFunctions::SQLRETURN (SQLHDBC SQLUSMALLINT SQLUSMALLINT*) "SQLGetFunctions")
   (macro SQLGetInfo::SQLRETURN (SQLHDBC SQLUSMALLINT SQLPOINTER SQLSMALLINT SQLSMALLINT*) "SQLGetInfo")
   (macro SQLGetStmtAttr::SQLRETURN (SQLHSTMT SQLINTEGER SQLPOINTER SQLINTEGER SQLINTEGER*) "SQLGetStmtAttr")
   (macro SQLGetStmtOption::SQLRETURN (SQLHSTMT SQLUSMALLINT SQLPOINTER) "SQLGetStmtOption")
   (macro SQLGetTypeInfo::SQLRETURN (SQLHSTMT SQLSMALLINT) "SQLGetTypeInfo")
   (macro SQLNumResultCols::SQLRETURN (SQLHSTMT SQLSMALLINT*) "SQLNumResultCols")
   (macro SQLParamData::SQLRETURN (SQLHSTMT SQLPOINTER*) "SQLParamData")
   (macro SQLPrepare::SQLRETURN (SQLHSTMT SQLCHAR* SQLINTEGER) "SQLPrepare")
   (macro SQLPutData::SQLRETURN (SQLHSTMT SQLPOINTER SQLINTEGER) "SQLPutData")
   (macro SQLRowCount::SQLRETURN (SQLHSTMT SQLINTEGER*) "SQLRowCount")
   (macro SQLSetConnectAttr::SQLRETURN (SQLHDBC SQLINTEGER SQLPOINTER SQLINTEGER) "SQLSetConnectAttr")
   (macro SQLSetConnectOption::SQLRETURN (SQLHDBC SQLUSMALLINT SQLUINTEGER) "SQLSetConnectOption")
   (macro SQLSetCursorName::SQLRETURN (SQLHSTMT SQLCHAR* SQLSMALLINT) "SQLSetCursorName")
   (macro SQLSetDescField::SQLRETURN (SQLHDESC SQLSMALLINT SQLSMALLINT SQLPOINTER SQLINTEGER) "SQLSetDescField")
   (macro SQLSetDescRec::SQLRETURN (SQLHDESC SQLSMALLINT SQLSMALLINT SQLSMALLINT SQLINTEGER SQLSMALLINT SQLSMALLINT SQLPOINTER SQLINTEGER* SQLINTEGER*) "SQLSetDescRec")
   (macro SQLSetEnvAttr::SQLRETURN (SQLHENV SQLINTEGER SQLPOINTER SQLINTEGER) "SQLSetEnvAttr")
   (macro SQLSetParam::SQLRETURN (SQLHSTMT SQLUSMALLINT SQLSMALLINT SQLSMALLINT SQLUINTEGER SQLSMALLINT SQLPOINTER SQLINTEGER*) "SQLSetParam")
   (macro SQLSetStmtAttr::SQLRETURN (SQLHSTMT SQLINTEGER SQLPOINTER SQLINTEGER) "SQLSetStmtAttr")
   (macro SQLSetStmtOption::SQLRETURN (SQLHSTMT SQLUSMALLINT SQLROWCOUNT) "SQLSetStmtOption")
   (macro SQLSpecialColumns::SQLRETURN (SQLHSTMT SQLUSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLUSMALLINT SQLUSMALLINT) "SQLSpecialColumns")
   (macro SQLStatistics::SQLRETURN (SQLHSTMT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLUSMALLINT SQLUSMALLINT) "SQLStatistics")
   (macro SQLTables::SQLRETURN (SQLHSTMT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT) "SQLTables")
   (macro SQLTransact::SQLRETURN (SQLHENV SQLHDBC SQLUSMALLINT) "SQLTransact")
   (macro SQLDriverConnect::SQLRETURN (SQLHDBC SQLHWND SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLSMALLINT* SQLUSMALLINT) "SQLDriverConnect")
   (macro SQLBrowseConnect::SQLRETURN (SQLHDBC SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLSMALLINT*) "SQLBrowseConnect")
   (macro SQLBulkOperations::SQLRETURN (SQLHSTMT SQLSMALLINT) "SQLBulkOperations")
   (macro SQLColAttributes::SQLRETURN (SQLHSTMT SQLUSMALLINT SQLUSMALLINT SQLPOINTER SQLSMALLINT SQLSMALLINT* SQLINTEGER*) "SQLColAttributes")
   (macro SQLColumnPrivileges::SQLRETURN (SQLHSTMT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT) "SQLColumnPrivileges")
   (macro SQLDescribeParam::SQLRETURN (SQLHSTMT SQLUSMALLINT SQLSMALLINT* SQLUINTEGER* SQLSMALLINT* SQLSMALLINT*) "SQLDescribeParam")
   (macro SQLExtendedFetch::SQLRETURN (SQLHSTMT SQLUSMALLINT SQLROWOFFSET SQLUINTEGER* SQLUSMALLINT*) "SQLExtendedFetch")
   (macro SQLForeignKeys::SQLRETURN (SQLHSTMT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT) "SQLForeignKeys")
   (macro SQLMoreResults::SQLRETURN (SQLHSTMT) "SQLMoreResults")
   (macro SQLNativeSql::SQLRETURN (SQLHDBC SQLCHAR* SQLINTEGER SQLCHAR* SQLINTEGER SQLINTEGER*) "SQLNativeSql")
   (macro SQLNumParams::SQLRETURN (SQLHSTMT SQLSMALLINT*) "SQLNumParams")
   (macro SQLParamOptions::SQLRETURN (SQLHSTMT SQLUINTEGER SQLUINTEGER*) "SQLParamOptions")
   (macro SQLPrimaryKeys::SQLRETURN (SQLHSTMT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT) "SQLPrimaryKeys")
   (macro SQLProcedureColumns::SQLRETURN (SQLHSTMT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT) "SQLProcedureColumns")
   (macro SQLProcedures::SQLRETURN (SQLHSTMT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT) "SQLProcedures")
   (macro SQLSetPos::SQLRETURN (SQLHSTMT SQLUSMALLINT SQLUSMALLINT SQLUSMALLINT) "SQLSetPos")
   (macro SQLTablePrivileges::SQLRETURN (SQLHSTMT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT) "SQLTablePrivileges")
   (macro SQLDrivers::SQLRETURN (SQLHENV SQLUSMALLINT SQLCHAR* SQLSMALLINT SQLSMALLINT* SQLCHAR* SQLSMALLINT SQLSMALLINT*) "SQLDrivers")
   (macro SQLBindParameter::SQLRETURN (SQLHSTMT SQLUSMALLINT SQLSMALLINT SQLSMALLINT SQLSMALLINT SQLUINTEGER SQLSMALLINT SQLPOINTER SQLINTEGER SQLINTEGER*) "SQLBindParameter")
   (macro SQLAllocHandleStd::SQLRETURN (SQLSMALLINT SQLHANDLE SQLHANDLE*) "SQLAllocHandleStd")
   (macro SQLSetScrollOptions::SQLRETURN (SQLHSTMT SQLUSMALLINT SQLINTEGER SQLUSMALLINT) "SQLSetScrollOptions")
   (macro TraceCloseLogFile::RETCODE (VOID) "TraceCloseLogFile")
   (macro TraceReturn::VOID (RETCODE RETCODE) "TraceReturn")
   (macro TraceVersion::DWORD (VOID) "TraceVersion")
   (macro TraceVSControl::RETCODE (DWORD) "TraceVSControl")
   (macro FireVSDebugEvent::VOID (PODBC_VS_ARGS) "FireVSDebugEvent")
   (macro SQLColAttributeW::SQLRETURN (SQLHSTMT SQLUSMALLINT SQLUSMALLINT SQLPOINTER SQLSMALLINT SQLSMALLINT* SQLPOINTER) "SQLColAttributeW")
   (macro SQLColAttributesW::SQLRETURN (SQLHSTMT SQLUSMALLINT SQLUSMALLINT SQLPOINTER SQLSMALLINT SQLSMALLINT* SQLINTEGER*) "SQLColAttributesW")
   (macro SQLConnectW::SQLRETURN (SQLHDBC SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT) "SQLConnectW")
   (macro SQLDescribeColW::SQLRETURN (SQLHSTMT SQLUSMALLINT SQLWCHAR* SQLSMALLINT SQLSMALLINT* SQLSMALLINT* SQLUINTEGER* SQLSMALLINT* SQLSMALLINT*) "SQLDescribeColW")
   (macro SQLErrorW::SQLRETURN (SQLHENV SQLHDBC SQLHSTMT SQLWCHAR* SQLINTEGER* SQLWCHAR* SQLSMALLINT SQLSMALLINT*) "SQLErrorW")
   (macro SQLExecDirectW::SQLRETURN (SQLHSTMT SQLWCHAR* SQLINTEGER) "SQLExecDirectW")
   (macro SQLGetConnectAttrW::SQLRETURN (SQLHDBC SQLINTEGER SQLPOINTER SQLINTEGER SQLINTEGER*) "SQLGetConnectAttrW")
   (macro SQLGetCursorNameW::SQLRETURN (SQLHSTMT SQLWCHAR* SQLSMALLINT SQLSMALLINT*) "SQLGetCursorNameW")
   (macro SQLSetDescFieldW::SQLRETURN (SQLHDESC SQLSMALLINT SQLSMALLINT SQLPOINTER SQLINTEGER) "SQLSetDescFieldW")
   (macro SQLGetDescFieldW::SQLRETURN (SQLHDESC SQLSMALLINT SQLSMALLINT SQLPOINTER SQLINTEGER SQLINTEGER*) "SQLGetDescFieldW")
   (macro SQLGetDescRecW::SQLRETURN (SQLHDESC SQLSMALLINT SQLWCHAR* SQLSMALLINT SQLSMALLINT* SQLSMALLINT* SQLSMALLINT* SQLINTEGER* SQLSMALLINT* SQLSMALLINT* SQLSMALLINT*) "SQLGetDescRecW")
   (macro SQLGetDiagFieldW::SQLRETURN (SQLSMALLINT SQLHANDLE SQLSMALLINT SQLSMALLINT SQLPOINTER SQLSMALLINT SQLSMALLINT*) "SQLGetDiagFieldW")
   (macro SQLGetDiagRecW::SQLRETURN (SQLSMALLINT SQLHANDLE SQLSMALLINT SQLWCHAR* SQLINTEGER* SQLWCHAR* SQLSMALLINT SQLSMALLINT*) "SQLGetDiagRecW")
   (macro SQLPrepareW::SQLRETURN (SQLHSTMT SQLWCHAR* SQLINTEGER) "SQLPrepareW")
   (macro SQLSetConnectAttrW::SQLRETURN (SQLHDBC SQLINTEGER SQLPOINTER SQLINTEGER) "SQLSetConnectAttrW")
   (macro SQLSetCursorNameW::SQLRETURN (SQLHSTMT SQLWCHAR* SQLSMALLINT) "SQLSetCursorNameW")
   (macro SQLColumnsW::SQLRETURN (SQLHSTMT SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT) "SQLColumnsW")
   (macro SQLGetConnectOptionW::SQLRETURN (SQLHDBC SQLUSMALLINT SQLPOINTER) "SQLGetConnectOptionW")
   (macro SQLGetInfoW::SQLRETURN (SQLHDBC SQLUSMALLINT SQLPOINTER SQLSMALLINT SQLSMALLINT*) "SQLGetInfoW")
   (macro SQLGetTypeInfoW::SQLRETURN (SQLHSTMT SQLSMALLINT) "SQLGetTypeInfoW")
   (macro SQLSetConnectOptionW::SQLRETURN (SQLHDBC SQLUSMALLINT SQLUINTEGER) "SQLSetConnectOptionW")
   (macro SQLSpecialColumnsW::SQLRETURN (SQLHSTMT SQLUSMALLINT SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT SQLUSMALLINT SQLUSMALLINT) "SQLSpecialColumnsW")
   (macro SQLStatisticsW::SQLRETURN (SQLHSTMT SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT SQLUSMALLINT SQLUSMALLINT) "SQLStatisticsW")
   (macro SQLTablesW::SQLRETURN (SQLHSTMT SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT) "SQLTablesW")
   (macro SQLDataSourcesW::SQLRETURN (SQLHENV SQLUSMALLINT SQLWCHAR* SQLSMALLINT SQLSMALLINT* SQLWCHAR* SQLSMALLINT SQLSMALLINT*) "SQLDataSourcesW")
   (macro SQLDriverConnectW::SQLRETURN (SQLHDBC SQLHWND SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT SQLSMALLINT* SQLUSMALLINT) "SQLDriverConnectW")
   (macro SQLBrowseConnectW::SQLRETURN (SQLHDBC SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT SQLSMALLINT*) "SQLBrowseConnectW")
   (macro SQLColumnPrivilegesW::SQLRETURN (SQLHSTMT SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT) "SQLColumnPrivilegesW")
   (macro SQLGetStmtAttrW::SQLRETURN (SQLHSTMT SQLINTEGER SQLPOINTER SQLINTEGER SQLINTEGER*) "SQLGetStmtAttrW")
   (macro SQLSetStmtAttrW::SQLRETURN (SQLHSTMT SQLINTEGER SQLPOINTER SQLINTEGER) "SQLSetStmtAttrW")
   (macro SQLForeignKeysW::SQLRETURN (SQLHSTMT SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT) "SQLForeignKeysW")
   (macro SQLNativeSqlW::SQLRETURN (SQLHDBC SQLWCHAR* SQLINTEGER SQLWCHAR* SQLINTEGER SQLINTEGER*) "SQLNativeSqlW")
   (macro SQLPrimaryKeysW::SQLRETURN (SQLHSTMT SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT) "SQLPrimaryKeysW")
   (macro SQLProcedureColumnsW::SQLRETURN (SQLHSTMT SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT) "SQLProcedureColumnsW")
   (macro SQLProceduresW::SQLRETURN (SQLHSTMT SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT) "SQLProceduresW")
   (macro SQLTablePrivilegesW::SQLRETURN (SQLHSTMT SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT SQLWCHAR* SQLSMALLINT) "SQLTablePrivilegesW")
   (macro SQLDriversW::SQLRETURN (SQLHENV SQLUSMALLINT SQLWCHAR* SQLSMALLINT SQLSMALLINT* SQLWCHAR* SQLSMALLINT SQLSMALLINT*) "SQLDriversW")
   (macro SQLColAttributeA::SQLRETURN (SQLHSTMT SQLSMALLINT SQLSMALLINT SQLPOINTER SQLSMALLINT SQLSMALLINT* SQLPOINTER) "SQLColAttributeA")
   (macro SQLColAttributesA::SQLRETURN (SQLHSTMT SQLUSMALLINT SQLUSMALLINT SQLPOINTER SQLSMALLINT SQLSMALLINT* SQLINTEGER*) "SQLColAttributesA")
   (macro SQLConnectA::SQLRETURN (SQLHDBC SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT) "SQLConnectA")
   (macro SQLDescribeColA::SQLRETURN (SQLHSTMT SQLUSMALLINT SQLCHAR* SQLSMALLINT SQLSMALLINT* SQLSMALLINT* SQLUINTEGER* SQLSMALLINT* SQLSMALLINT*) "SQLDescribeColA")
   (macro SQLErrorA::SQLRETURN (SQLHENV SQLHDBC SQLHSTMT SQLCHAR* SQLINTEGER* SQLCHAR* SQLSMALLINT SQLSMALLINT*) "SQLErrorA")
   (macro SQLExecDirectA::SQLRETURN (SQLHSTMT SQLCHAR* SQLINTEGER) "SQLExecDirectA")
   (macro SQLGetConnectAttrA::SQLRETURN (SQLHDBC SQLINTEGER SQLPOINTER SQLINTEGER SQLINTEGER*) "SQLGetConnectAttrA")
   (macro SQLGetCursorNameA::SQLRETURN (SQLHSTMT SQLCHAR* SQLSMALLINT SQLSMALLINT*) "SQLGetCursorNameA")
   (macro SQLGetDescFieldA::SQLRETURN (SQLHDESC SQLSMALLINT SQLSMALLINT SQLPOINTER SQLINTEGER SQLINTEGER*) "SQLGetDescFieldA")
   (macro SQLGetDescRecA::SQLRETURN (SQLHDESC SQLSMALLINT SQLCHAR* SQLSMALLINT SQLSMALLINT* SQLSMALLINT* SQLSMALLINT* SQLINTEGER* SQLSMALLINT* SQLSMALLINT* SQLSMALLINT*) "SQLGetDescRecA")
   (macro SQLGetDiagFieldA::SQLRETURN (SQLSMALLINT SQLHANDLE SQLSMALLINT SQLSMALLINT SQLPOINTER SQLSMALLINT SQLSMALLINT*) "SQLGetDiagFieldA")
   (macro SQLGetDiagRecA::SQLRETURN (SQLSMALLINT SQLHANDLE SQLSMALLINT SQLCHAR* SQLINTEGER* SQLCHAR* SQLSMALLINT SQLSMALLINT*) "SQLGetDiagRecA")
   (macro SQLGetStmtAttrA::SQLRETURN (SQLHSTMT SQLINTEGER SQLPOINTER SQLINTEGER SQLINTEGER*) "SQLGetStmtAttrA")
   (macro SQLGetTypeInfoA::SQLRETURN (SQLHSTMT SQLSMALLINT) "SQLGetTypeInfoA")
   (macro SQLPrepareA::SQLRETURN (SQLHSTMT SQLCHAR* SQLINTEGER) "SQLPrepareA")
   (macro SQLSetConnectAttrA::SQLRETURN (SQLHDBC SQLINTEGER SQLPOINTER SQLINTEGER) "SQLSetConnectAttrA")
   (macro SQLSetCursorNameA::SQLRETURN (SQLHSTMT SQLCHAR* SQLSMALLINT) "SQLSetCursorNameA")
   (macro SQLColumnsA::SQLRETURN (SQLHSTMT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT) "SQLColumnsA")
   (macro SQLGetConnectOptionA::SQLRETURN (SQLHDBC SQLUSMALLINT SQLPOINTER) "SQLGetConnectOptionA")
   (macro SQLGetInfoA::SQLRETURN (SQLHDBC SQLUSMALLINT SQLPOINTER SQLSMALLINT SQLSMALLINT*) "SQLGetInfoA")
   (macro SQLGetStmtOptionA::SQLRETURN (SQLHSTMT SQLUSMALLINT SQLPOINTER) "SQLGetStmtOptionA")
   (macro SQLSetConnectOptionA::SQLRETURN (SQLHDBC SQLUSMALLINT SQLUINTEGER) "SQLSetConnectOptionA")
   (macro SQLSetStmtOptionA::SQLRETURN (SQLHSTMT SQLUSMALLINT SQLUINTEGER) "SQLSetStmtOptionA")
   (macro SQLSpecialColumnsA::SQLRETURN (SQLHSTMT SQLUSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLUSMALLINT SQLUSMALLINT) "SQLSpecialColumnsA")
   (macro SQLStatisticsA::SQLRETURN (SQLHSTMT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLUSMALLINT SQLUSMALLINT) "SQLStatisticsA")
   (macro SQLTablesA::SQLRETURN (SQLHSTMT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT) "SQLTablesA")
   (macro SQLDataSourcesA::SQLRETURN (SQLHENV SQLUSMALLINT SQLCHAR* SQLSMALLINT SQLSMALLINT* SQLCHAR* SQLSMALLINT SQLSMALLINT*) "SQLDataSourcesA")
   (macro SQLDriverConnectA::SQLRETURN (SQLHDBC SQLHWND SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLSMALLINT* SQLUSMALLINT) "SQLDriverConnectA")
   (macro SQLBrowseConnectA::SQLRETURN (SQLHDBC SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLSMALLINT*) "SQLBrowseConnectA")
   (macro SQLColumnPrivilegesA::SQLRETURN (SQLHSTMT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT) "SQLColumnPrivilegesA")
   (macro SQLDescribeParamA::SQLRETURN (SQLHSTMT SQLUSMALLINT SQLSMALLINT* SQLUINTEGER* SQLSMALLINT* SQLSMALLINT*) "SQLDescribeParamA")
   (macro SQLForeignKeysA::SQLRETURN (SQLHSTMT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT) "SQLForeignKeysA")
   (macro SQLNativeSqlA::SQLRETURN (SQLHDBC SQLCHAR* SQLINTEGER SQLCHAR* SQLINTEGER SQLINTEGER*) "SQLNativeSqlA")
   (macro SQLPrimaryKeysA::SQLRETURN (SQLHSTMT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT) "SQLPrimaryKeysA")
   (macro SQLProcedureColumnsA::SQLRETURN (SQLHSTMT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT) "SQLProcedureColumnsA")
   (macro SQLProceduresA::SQLRETURN (SQLHSTMT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT) "SQLProceduresA")
   (macro SQLTablePrivilegesA::SQLRETURN (SQLHSTMT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT SQLCHAR* SQLSMALLINT) "SQLTablePrivilegesA")
   (macro SQLDriversA::SQLRETURN (SQLHENV SQLUSMALLINT SQLCHAR* SQLSMALLINT SQLSMALLINT* SQLCHAR* SQLSMALLINT SQLSMALLINT*) "SQLDriversA")
   (type HWND void* "HWND")
   (type CHAR char "CHAR")
   (type TCHAR char "TCHAR")
   (type VOID void "VOID")
   (type WORD ushort "WORD")
   (type DWORD ulong "DWORD")
   (type BYTE uchar "BYTE")
   (type WCHAR ushort "WCHAR")
   (type WCHAR* (pointer WCHAR) "WCHAR *")
   (type LPWSTR WCHAR* "LPWSTR")
   (type LPCSTR string "LPCSTR")
   (type TCHAR* (pointer TCHAR) "TCHAR *")
   (type LPTSTR TCHAR* "LPTSTR")
   (type LPSTR string "LPSTR")
   (type DWORD* (pointer DWORD) "DWORD *")
   (type LPDWORD DWORD* "LPDWORD")
   (type HINSTANCE void* "HINSTANCE")
   (type SQLCHAR uchar "SQLCHAR")
   (type SQLDATE uchar "SQLDATE")
   (type SQLDECIMAL uchar "SQLDECIMAL")
   (type SQLDOUBLE double "SQLDOUBLE")
   (type SQLFLOAT double "SQLFLOAT")
   (type SQLINTEGER long "SQLINTEGER")
   (type SQLUINTEGER ulong "SQLUINTEGER")
   (type SQLROWCOUNT SQLUINTEGER "SQLROWCOUNT")
   (type SQLROWSETSIZE SQLUINTEGER "SQLROWSETSIZE")
   (type SQLTRANSID SQLUINTEGER "SQLTRANSID")
   (type SQLROWOFFSET SQLINTEGER "SQLROWOFFSET")
   (type SQLNUMERIC uchar "SQLNUMERIC")
   (type SQLPOINTER void* "SQLPOINTER")
   (type SQLREAL float "SQLREAL")
   (type SQLSMALLINT short "SQLSMALLINT")
   (type SQLUSMALLINT ushort "SQLUSMALLINT")
   (type SQLTIME uchar "SQLTIME")
   (type SQLTIMESTAMP uchar "SQLTIMESTAMP")
   (type SQLVARCHAR uchar "SQLVARCHAR")
   (type SQLRETURN SQLSMALLINT "SQLRETURN")
   (type SQLHANDLE void* "SQLHANDLE")
   (type SQLHENV SQLHANDLE "SQLHENV")
   (type SQLHDBC SQLHANDLE "SQLHDBC")
   (type SQLHSTMT SQLHANDLE "SQLHSTMT")
   (type SQLHDESC SQLHANDLE "SQLHDESC")
   (type HENV SQLHANDLE "HENV")
   (type HDBC SQLHANDLE "HDBC")
   (type HSTMT SQLHANDLE "HSTMT")
   (type UCHAR uchar "UCHAR")
   (type SCHAR char "SCHAR")   
;   (type SCHAR schar "SCHAR")
   (type SQLSCHAR SCHAR "SQLSCHAR")
   (type SDWORD long "SDWORD")
   (type UDWORD ulong "UDWORD")
   (type SWORD short "SWORD")
   (type UWORD ushort "UWORD")
   (type UINT uint "UINT")
   (type SLONG long "SLONG")
   (type SSHORT short "SSHORT")
   (type ULONG ulong "ULONG")
   (type USHORT ushort "USHORT")
   (type SDOUBLE double "SDOUBLE")
   (type LDOUBLE double "LDOUBLE")
   (type SFLOAT float "SFLOAT")
   (type PTR void* "PTR")
   (type RETCODE short "RETCODE")
   (type SQLHWND void* "SQLHWND")
   (type s-tagDATE_STRUCT (struct (year::SQLSMALLINT "year") (month::SQLUSMALLINT "month") (day::SQLUSMALLINT "day")) "struct tagDATE_STRUCT")
   (type DATE_STRUCT s-tagDATE_STRUCT "DATE_STRUCT")
   (type SQL_DATE_STRUCT DATE_STRUCT "SQL_DATE_STRUCT")
   (type s-tagTIME_STRUCT (struct (hour::SQLUSMALLINT "hour") (minute::SQLUSMALLINT "minute") (second::SQLUSMALLINT "second")) "struct tagTIME_STRUCT")
   (type TIME_STRUCT s-tagTIME_STRUCT "TIME_STRUCT")
   (type SQL_TIME_STRUCT TIME_STRUCT "SQL_TIME_STRUCT")
   (type s-tagTIMESTAMP_STRUCT (struct (year::SQLSMALLINT "year") (month::SQLUSMALLINT "month") (day::SQLUSMALLINT "day") (hour::SQLUSMALLINT "hour") (minute::SQLUSMALLINT "minute") (second::SQLUSMALLINT "second") (fraction::SQLUINTEGER "fraction")) "struct tagTIMESTAMP_STRUCT")
   (type TIMESTAMP_STRUCT s-tagTIMESTAMP_STRUCT "TIMESTAMP_STRUCT")
   (type SQL_TIMESTAMP_STRUCT TIMESTAMP_STRUCT "SQL_TIMESTAMP_STRUCT")
   (type bigsql2__e1004 (enum (SQL_IS_YEAR "SQL_IS_YEAR") (SQL_IS_MONTH "SQL_IS_MONTH") (SQL_IS_DAY "SQL_IS_DAY") (SQL_IS_HOUR "SQL_IS_HOUR") (SQL_IS_MINUTE "SQL_IS_MINUTE") (SQL_IS_SECOND "SQL_IS_SECOND") (SQL_IS_YEAR_TO_MONTH "SQL_IS_YEAR_TO_MONTH") (SQL_IS_DAY_TO_HOUR "SQL_IS_DAY_TO_HOUR") (SQL_IS_DAY_TO_MINUTE "SQL_IS_DAY_TO_MINUTE") (SQL_IS_DAY_TO_SECOND "SQL_IS_DAY_TO_SECOND") (SQL_IS_HOUR_TO_MINUTE "SQL_IS_HOUR_TO_MINUTE") (SQL_IS_HOUR_TO_SECOND "SQL_IS_HOUR_TO_SECOND") (SQL_IS_MINUTE_TO_SECOND "SQL_IS_MINUTE_TO_SECOND")) "long")
   (type SQLINTERVAL bigsql2__e1004 "SQLINTERVAL")
   (type s-tagSQL_YEAR_MONTH (struct (year::SQLUINTEGER "year") (month::SQLUINTEGER "month")) "struct tagSQL_YEAR_MONTH")
   (type SQL_YEAR_MONTH_STRUCT s-tagSQL_YEAR_MONTH "SQL_YEAR_MONTH_STRUCT")
   (type s-tagSQL_DAY_SECOND (struct (day::SQLUINTEGER "day") (hour::SQLUINTEGER "hour") (minute::SQLUINTEGER "minute") (second::SQLUINTEGER "second") (fraction::SQLUINTEGER "fraction")) "struct tagSQL_DAY_SECOND")
   (type SQL_DAY_SECOND_STRUCT s-tagSQL_DAY_SECOND "SQL_DAY_SECOND_STRUCT")
   (type s-tagSQL_INTERVAL_STRUCT (struct (interval_type::SQLINTERVAL "interval_type") (interval_sign::SQLSMALLINT "interval_sign") (intval::s-bigsql2__s1001 "intval")) "struct tagSQL_INTERVAL_STRUCT")
   (type s-bigsql2__s1001 (union (year_month::SQL_YEAR_MONTH_STRUCT "year_month") (day_second::SQL_DAY_SECOND_STRUCT "day_second")) "void")
   (type SQL_INTERVAL_STRUCT s-tagSQL_INTERVAL_STRUCT "SQL_INTERVAL_STRUCT")
   (type s-__bigint_struct (struct (hiword::int "hiword") (loword::uint "loword")) "struct __bigint_struct")
   (type s-__bigint_struct_u (struct (hiword::uint "hiword") (loword::uint "loword")) "struct __bigint_struct_u")
   (type SQLBIGINT s-__bigint_struct "SQLBIGINT")
   (type SQLUBIGINT s-__bigint_struct_u "SQLUBIGINT")
   (type s-tagSQL_NUMERIC_STRUCT (struct (precision::SQLCHAR "precision") (scale::SQLSCHAR "scale") (sign::SQLCHAR "sign") (val::SQLCHAR-array-16 "val")) "struct tagSQL_NUMERIC_STRUCT")
   (type SQLCHAR-array-16 (array SQLCHAR) "SQLCHAR $[ 16 ]")
   (type SQL_NUMERIC_STRUCT s-tagSQL_NUMERIC_STRUCT "SQL_NUMERIC_STRUCT")
   (type s-tagSQLGUID (struct (Data1::DWORD "Data1") (Data2::WORD "Data2") (Data3::WORD "Data3") (Data4::BYTE-array-8 "Data4")) "struct tagSQLGUID")
   (type BYTE-array-8 (array BYTE) "BYTE $[ 8 ]")
   (type SQLGUID s-tagSQLGUID "SQLGUID")
   (type BOOKMARK SQLUINTEGER "BOOKMARK")
   (type SQLWCHAR WCHAR "SQLWCHAR")
   (type SQLTCHAR SQLCHAR "SQLTCHAR")
   (type s-tagODBC_VS_ARGS (struct (pguidEvent::void* "pguidEvent") (dwFlags::DWORD "dwFlags") (u1::s-bigsql2__s1002 "u1") (u2::s-bigsql2__s1003 "u2") (RetCode::RETCODE "RetCode")) "struct tagODBC_VS_ARGS")
   (type s-bigsql2__s1002 (union (wszArg::WCHAR* "wszArg") (szArg::CHAR* "szArg")) "void")
   (type CHAR* (pointer CHAR) "CHAR *")
   (type s-bigsql2__s1003 (union (wszCorrelation::WCHAR* "wszCorrelation") (szCorrelation::CHAR* "szCorrelation")) "void")
   (type ODBC_VS_ARGS s-tagODBC_VS_ARGS "ODBC_VS_ARGS")
   (type PODBC_VS_ARGS s-tagODBC_VS_ARGS* "PODBC_VS_ARGS")
   (type SQLHDBC* (pointer SQLHDBC) "SQLHDBC *")
   (type SQLHENV,SQLHDBC*->SQLRETURN "SQLRETURN ($(SQLHENV,SQLHDBC *))")
   (type SQLHENV* (pointer SQLHENV) "SQLHENV *")
   (type SQLHENV*->SQLRETURN "SQLRETURN ($(SQLHENV *))")
   (type SQLHANDLE* (pointer SQLHANDLE) "SQLHANDLE *")
   (type SQLSMALLINT,SQLHANDLE,SQLHANDLE*->SQLRETURN "SQLRETURN ($(SQLSMALLINT,SQLHANDLE,SQLHANDLE *))")
   (type SQLHSTMT* (pointer SQLHSTMT) "SQLHSTMT *")
   (type SQLHDBC,SQLHSTMT*->SQLRETURN "SQLRETURN ($(SQLHDBC,SQLHSTMT *))")
   (type SQLINTEGER* (pointer SQLINTEGER) "SQLINTEGER *")
   (type SQLHSTMT,SQLUSMALLINT,SQLSMALLINT,SQLPOINTER,SQLINTEGER,SQLINTEGER*->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLUSMALLINT,SQLSMALLINT,SQLPOINTER,SQLINTEGER,SQLINTEGER *))")
   (type SQLHSTMT,SQLUSMALLINT,SQLSMALLINT,SQLSMALLINT,SQLUINTEGER,SQLSMALLINT,SQLPOINTER,SQLINTEGER*->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLUSMALLINT,SQLSMALLINT,SQLSMALLINT,SQLUINTEGER,SQLSMALLINT,SQLPOINTER,SQLINTEGER *))")
   (type SQLHSTMT->SQLRETURN "SQLRETURN ($(SQLHSTMT))")
   (type SQLSMALLINT* (pointer SQLSMALLINT) "SQLSMALLINT *")
   (type SQLHSTMT,SQLUSMALLINT,SQLUSMALLINT,SQLPOINTER,SQLSMALLINT,SQLSMALLINT*,SQLPOINTER->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLUSMALLINT,SQLUSMALLINT,SQLPOINTER,SQLSMALLINT,SQLSMALLINT *,SQLPOINTER))")
   (type SQLCHAR* (pointer SQLCHAR) "SQLCHAR *")
   (type SQLHSTMT,SQLCHAR*,SQLSMALLINT,SQLCHAR*,SQLSMALLINT,SQLCHAR*,SQLSMALLINT,SQLCHAR*,SQLSMALLINT->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLCHAR *,SQLSMALLINT,SQLCHAR *,SQLSMALLINT,SQLCHAR *,SQLSMALLINT,SQLCHAR *,SQLSMALLINT))")
   (type SQLHDBC,SQLCHAR*,SQLSMALLINT,SQLCHAR*,SQLSMALLINT,SQLCHAR*,SQLSMALLINT->SQLRETURN "SQLRETURN ($(SQLHDBC,SQLCHAR *,SQLSMALLINT,SQLCHAR *,SQLSMALLINT,SQLCHAR *,SQLSMALLINT))")
   (type SQLHDESC,SQLHDESC->SQLRETURN "SQLRETURN ($(SQLHDESC,SQLHDESC))")
   (type SQLHENV,SQLUSMALLINT,SQLCHAR*,SQLSMALLINT,SQLSMALLINT*,SQLCHAR*,SQLSMALLINT,SQLSMALLINT*->SQLRETURN "SQLRETURN ($(SQLHENV,SQLUSMALLINT,SQLCHAR *,SQLSMALLINT,SQLSMALLINT *,SQLCHAR *,SQLSMALLINT,SQLSMALLINT *))")
   (type SQLUINTEGER* (pointer SQLUINTEGER) "SQLUINTEGER *")
   (type SQLHSTMT,SQLUSMALLINT,SQLCHAR*,SQLSMALLINT,SQLSMALLINT*,SQLSMALLINT*,SQLUINTEGER*,SQLSMALLINT*,SQLSMALLINT*->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLUSMALLINT,SQLCHAR *,SQLSMALLINT,SQLSMALLINT *,SQLSMALLINT *,SQLUINTEGER *,SQLSMALLINT *,SQLSMALLINT *))")
   (type SQLHDBC->SQLRETURN "SQLRETURN ($(SQLHDBC))")
   (type SQLSMALLINT,SQLHANDLE,SQLSMALLINT->SQLRETURN "SQLRETURN ($(SQLSMALLINT,SQLHANDLE,SQLSMALLINT))")
   (type SQLHENV,SQLHDBC,SQLHSTMT,SQLCHAR*,SQLINTEGER*,SQLCHAR*,SQLSMALLINT,SQLSMALLINT*->SQLRETURN "SQLRETURN ($(SQLHENV,SQLHDBC,SQLHSTMT,SQLCHAR *,SQLINTEGER *,SQLCHAR *,SQLSMALLINT,SQLSMALLINT *))")
   (type SQLHSTMT,SQLCHAR*,SQLINTEGER->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLCHAR *,SQLINTEGER))")
   (type SQLHSTMT,SQLSMALLINT,SQLROWOFFSET->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLSMALLINT,SQLROWOFFSET))")
   (type SQLHENV->SQLRETURN "SQLRETURN ($(SQLHENV))")
   (type SQLSMALLINT,SQLHANDLE->SQLRETURN "SQLRETURN ($(SQLSMALLINT,SQLHANDLE))")
   (type SQLHSTMT,SQLUSMALLINT->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLUSMALLINT))")
   (type SQLHDBC,SQLINTEGER,SQLPOINTER,SQLINTEGER,SQLINTEGER*->SQLRETURN "SQLRETURN ($(SQLHDBC,SQLINTEGER,SQLPOINTER,SQLINTEGER,SQLINTEGER *))")
   (type SQLHDBC,SQLUSMALLINT,SQLPOINTER->SQLRETURN "SQLRETURN ($(SQLHDBC,SQLUSMALLINT,SQLPOINTER))")
   (type SQLHSTMT,SQLCHAR*,SQLSMALLINT,SQLSMALLINT*->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLCHAR *,SQLSMALLINT,SQLSMALLINT *))")
   (type SQLHDESC,SQLSMALLINT,SQLSMALLINT,SQLPOINTER,SQLINTEGER,SQLINTEGER*->SQLRETURN "SQLRETURN ($(SQLHDESC,SQLSMALLINT,SQLSMALLINT,SQLPOINTER,SQLINTEGER,SQLINTEGER *))")
   (type SQLHDESC,SQLSMALLINT,SQLCHAR*,SQLSMALLINT,SQLSMALLINT*,SQLSMALLINT*,SQLSMALLINT*,SQLINTEGER*,SQLSMALLINT*,SQLSMALLINT*,SQLSMALLINT*->SQLRETURN "SQLRETURN ($(SQLHDESC,SQLSMALLINT,SQLCHAR *,SQLSMALLINT,SQLSMALLINT *,SQLSMALLINT *,SQLSMALLINT *,SQLINTEGER *,SQLSMALLINT *,SQLSMALLINT *,SQLSMALLINT *))")
   (type SQLSMALLINT,SQLHANDLE,SQLSMALLINT,SQLSMALLINT,SQLPOINTER,SQLSMALLINT,SQLSMALLINT*->SQLRETURN "SQLRETURN ($(SQLSMALLINT,SQLHANDLE,SQLSMALLINT,SQLSMALLINT,SQLPOINTER,SQLSMALLINT,SQLSMALLINT *))")
   (type SQLSMALLINT,SQLHANDLE,SQLSMALLINT,SQLCHAR*,SQLINTEGER*,SQLCHAR*,SQLSMALLINT,SQLSMALLINT*->SQLRETURN "SQLRETURN ($(SQLSMALLINT,SQLHANDLE,SQLSMALLINT,SQLCHAR *,SQLINTEGER *,SQLCHAR *,SQLSMALLINT,SQLSMALLINT *))")
   (type SQLHENV,SQLINTEGER,SQLPOINTER,SQLINTEGER,SQLINTEGER*->SQLRETURN "SQLRETURN ($(SQLHENV,SQLINTEGER,SQLPOINTER,SQLINTEGER,SQLINTEGER *))")
   (type SQLUSMALLINT* (pointer SQLUSMALLINT) "SQLUSMALLINT *")
   (type SQLHDBC,SQLUSMALLINT,SQLUSMALLINT*->SQLRETURN "SQLRETURN ($(SQLHDBC,SQLUSMALLINT,SQLUSMALLINT *))")
   (type SQLHDBC,SQLUSMALLINT,SQLPOINTER,SQLSMALLINT,SQLSMALLINT*->SQLRETURN "SQLRETURN ($(SQLHDBC,SQLUSMALLINT,SQLPOINTER,SQLSMALLINT,SQLSMALLINT *))")
   (type SQLHSTMT,SQLINTEGER,SQLPOINTER,SQLINTEGER,SQLINTEGER*->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLINTEGER,SQLPOINTER,SQLINTEGER,SQLINTEGER *))")
   (type SQLHSTMT,SQLUSMALLINT,SQLPOINTER->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLUSMALLINT,SQLPOINTER))")
   (type SQLHSTMT,SQLSMALLINT->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLSMALLINT))")
   (type SQLHSTMT,SQLSMALLINT*->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLSMALLINT *))")
   (type SQLPOINTER* (pointer SQLPOINTER) "SQLPOINTER *")
   (type SQLHSTMT,SQLPOINTER*->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLPOINTER *))")
   (type SQLHSTMT,SQLPOINTER,SQLINTEGER->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLPOINTER,SQLINTEGER))")
   (type SQLHSTMT,SQLINTEGER*->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLINTEGER *))")
   (type SQLHDBC,SQLINTEGER,SQLPOINTER,SQLINTEGER->SQLRETURN "SQLRETURN ($(SQLHDBC,SQLINTEGER,SQLPOINTER,SQLINTEGER))")
   (type SQLHDBC,SQLUSMALLINT,SQLUINTEGER->SQLRETURN "SQLRETURN ($(SQLHDBC,SQLUSMALLINT,SQLUINTEGER))")
   (type SQLHSTMT,SQLCHAR*,SQLSMALLINT->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLCHAR *,SQLSMALLINT))")
   (type SQLHDESC,SQLSMALLINT,SQLSMALLINT,SQLPOINTER,SQLINTEGER->SQLRETURN "SQLRETURN ($(SQLHDESC,SQLSMALLINT,SQLSMALLINT,SQLPOINTER,SQLINTEGER))")
   (type SQLHDESC,SQLSMALLINT,SQLSMALLINT,SQLSMALLINT,SQLINTEGER,SQLSMALLINT,SQLSMALLINT,SQLPOINTER,SQLINTEGER*,SQLINTEGER*->SQLRETURN "SQLRETURN ($(SQLHDESC,SQLSMALLINT,SQLSMALLINT,SQLSMALLINT,SQLINTEGER,SQLSMALLINT,SQLSMALLINT,SQLPOINTER,SQLINTEGER *,SQLINTEGER *))")
   (type SQLHENV,SQLINTEGER,SQLPOINTER,SQLINTEGER->SQLRETURN "SQLRETURN ($(SQLHENV,SQLINTEGER,SQLPOINTER,SQLINTEGER))")
   (type SQLHSTMT,SQLINTEGER,SQLPOINTER,SQLINTEGER->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLINTEGER,SQLPOINTER,SQLINTEGER))")
   (type SQLHSTMT,SQLUSMALLINT,SQLROWCOUNT->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLUSMALLINT,SQLROWCOUNT))")
   (type SQLHSTMT,SQLUSMALLINT,SQLCHAR*,SQLSMALLINT,SQLCHAR*,SQLSMALLINT,SQLCHAR*,SQLSMALLINT,SQLUSMALLINT,SQLUSMALLINT->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLUSMALLINT,SQLCHAR *,SQLSMALLINT,SQLCHAR *,SQLSMALLINT,SQLCHAR *,SQLSMALLINT,SQLUSMALLINT,SQLUSMALLINT))")
   (type SQLHSTMT,SQLCHAR*,SQLSMALLINT,SQLCHAR*,SQLSMALLINT,SQLCHAR*,SQLSMALLINT,SQLUSMALLINT,SQLUSMALLINT->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLCHAR *,SQLSMALLINT,SQLCHAR *,SQLSMALLINT,SQLCHAR *,SQLSMALLINT,SQLUSMALLINT,SQLUSMALLINT))")
   (type SQLHENV,SQLHDBC,SQLUSMALLINT->SQLRETURN "SQLRETURN ($(SQLHENV,SQLHDBC,SQLUSMALLINT))")
   (type SQLHDBC,SQLHWND,SQLCHAR*,SQLSMALLINT,SQLCHAR*,SQLSMALLINT,SQLSMALLINT*,SQLUSMALLINT->SQLRETURN "SQLRETURN ($(SQLHDBC,SQLHWND,SQLCHAR *,SQLSMALLINT,SQLCHAR *,SQLSMALLINT,SQLSMALLINT *,SQLUSMALLINT))")
   (type SQLHDBC,SQLCHAR*,SQLSMALLINT,SQLCHAR*,SQLSMALLINT,SQLSMALLINT*->SQLRETURN "SQLRETURN ($(SQLHDBC,SQLCHAR *,SQLSMALLINT,SQLCHAR *,SQLSMALLINT,SQLSMALLINT *))")
   (type SQLHSTMT,SQLUSMALLINT,SQLUSMALLINT,SQLPOINTER,SQLSMALLINT,SQLSMALLINT*,SQLINTEGER*->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLUSMALLINT,SQLUSMALLINT,SQLPOINTER,SQLSMALLINT,SQLSMALLINT *,SQLINTEGER *))")
   (type SQLHSTMT,SQLUSMALLINT,SQLSMALLINT*,SQLUINTEGER*,SQLSMALLINT*,SQLSMALLINT*->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLUSMALLINT,SQLSMALLINT *,SQLUINTEGER *,SQLSMALLINT *,SQLSMALLINT *))")
   (type SQLROWSETSIZE* (pointer SQLROWSETSIZE) "SQLROWSETSIZE *")
   (type SQLHSTMT,SQLUSMALLINT,SQLROWOFFSET,SQLROWSETSIZE*,SQLUSMALLINT*->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLUSMALLINT,SQLROWOFFSET,SQLROWSETSIZE *,SQLUSMALLINT *))")
   (type SQLHSTMT,SQLCHAR*,SQLSMALLINT,SQLCHAR*,SQLSMALLINT,SQLCHAR*,SQLSMALLINT,SQLCHAR*,SQLSMALLINT,SQLCHAR*,SQLSMALLINT,SQLCHAR*,SQLSMALLINT->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLCHAR *,SQLSMALLINT,SQLCHAR *,SQLSMALLINT,SQLCHAR *,SQLSMALLINT,SQLCHAR *,SQLSMALLINT,SQLCHAR *,SQLSMALLINT,SQLCHAR *,SQLSMALLINT))")
   (type SQLHDBC,SQLCHAR*,SQLINTEGER,SQLCHAR*,SQLINTEGER,SQLINTEGER*->SQLRETURN "SQLRETURN ($(SQLHDBC,SQLCHAR *,SQLINTEGER,SQLCHAR *,SQLINTEGER,SQLINTEGER *))")
   (type SQLHSTMT,SQLUINTEGER,SQLUINTEGER*->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLUINTEGER,SQLUINTEGER *))")
   (type SQLHSTMT,SQLCHAR*,SQLSMALLINT,SQLCHAR*,SQLSMALLINT,SQLCHAR*,SQLSMALLINT->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLCHAR *,SQLSMALLINT,SQLCHAR *,SQLSMALLINT,SQLCHAR *,SQLSMALLINT))")
   (type SQLHSTMT,SQLUSMALLINT,SQLUSMALLINT,SQLUSMALLINT->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLUSMALLINT,SQLUSMALLINT,SQLUSMALLINT))")
   (type SQLHSTMT,SQLUSMALLINT,SQLSMALLINT,SQLSMALLINT,SQLSMALLINT,SQLUINTEGER,SQLSMALLINT,SQLPOINTER,SQLINTEGER,SQLINTEGER*->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLUSMALLINT,SQLSMALLINT,SQLSMALLINT,SQLSMALLINT,SQLUINTEGER,SQLSMALLINT,SQLPOINTER,SQLINTEGER,SQLINTEGER *))")
   (type SQLHSTMT,SQLUSMALLINT,SQLINTEGER,SQLUSMALLINT->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLUSMALLINT,SQLINTEGER,SQLUSMALLINT))")
   (type VOID->RETCODE "RETCODE ($(VOID))")
   (type RETCODE,RETCODE->VOID "VOID ($(RETCODE,RETCODE))")
   (type VOID->DWORD "DWORD ($(VOID))")
   (type DWORD->RETCODE "RETCODE ($(DWORD))")
   (type PODBC_VS_ARGS->VOID "VOID ($(PODBC_VS_ARGS))")
   (type SQLWCHAR* (pointer SQLWCHAR) "SQLWCHAR *")
   (type SQLHDBC,SQLWCHAR*,SQLSMALLINT,SQLWCHAR*,SQLSMALLINT,SQLWCHAR*,SQLSMALLINT->SQLRETURN "SQLRETURN ($(SQLHDBC,SQLWCHAR *,SQLSMALLINT,SQLWCHAR *,SQLSMALLINT,SQLWCHAR *,SQLSMALLINT))")
   (type SQLHSTMT,SQLUSMALLINT,SQLWCHAR*,SQLSMALLINT,SQLSMALLINT*,SQLSMALLINT*,SQLUINTEGER*,SQLSMALLINT*,SQLSMALLINT*->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLUSMALLINT,SQLWCHAR *,SQLSMALLINT,SQLSMALLINT *,SQLSMALLINT *,SQLUINTEGER *,SQLSMALLINT *,SQLSMALLINT *))")
   (type SQLHENV,SQLHDBC,SQLHSTMT,SQLWCHAR*,SQLINTEGER*,SQLWCHAR*,SQLSMALLINT,SQLSMALLINT*->SQLRETURN "SQLRETURN ($(SQLHENV,SQLHDBC,SQLHSTMT,SQLWCHAR *,SQLINTEGER *,SQLWCHAR *,SQLSMALLINT,SQLSMALLINT *))")
   (type SQLHSTMT,SQLWCHAR*,SQLINTEGER->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLWCHAR *,SQLINTEGER))")
   (type SQLHSTMT,SQLWCHAR*,SQLSMALLINT,SQLSMALLINT*->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLWCHAR *,SQLSMALLINT,SQLSMALLINT *))")
   (type SQLHDESC,SQLSMALLINT,SQLWCHAR*,SQLSMALLINT,SQLSMALLINT*,SQLSMALLINT*,SQLSMALLINT*,SQLINTEGER*,SQLSMALLINT*,SQLSMALLINT*,SQLSMALLINT*->SQLRETURN "SQLRETURN ($(SQLHDESC,SQLSMALLINT,SQLWCHAR *,SQLSMALLINT,SQLSMALLINT *,SQLSMALLINT *,SQLSMALLINT *,SQLINTEGER *,SQLSMALLINT *,SQLSMALLINT *,SQLSMALLINT *))")
   (type SQLSMALLINT,SQLHANDLE,SQLSMALLINT,SQLWCHAR*,SQLINTEGER*,SQLWCHAR*,SQLSMALLINT,SQLSMALLINT*->SQLRETURN "SQLRETURN ($(SQLSMALLINT,SQLHANDLE,SQLSMALLINT,SQLWCHAR *,SQLINTEGER *,SQLWCHAR *,SQLSMALLINT,SQLSMALLINT *))")
   (type SQLHSTMT,SQLWCHAR*,SQLSMALLINT->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLWCHAR *,SQLSMALLINT))")
   (type SQLHSTMT,SQLWCHAR*,SQLSMALLINT,SQLWCHAR*,SQLSMALLINT,SQLWCHAR*,SQLSMALLINT,SQLWCHAR*,SQLSMALLINT->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLWCHAR *,SQLSMALLINT,SQLWCHAR *,SQLSMALLINT,SQLWCHAR *,SQLSMALLINT,SQLWCHAR *,SQLSMALLINT))")
   (type SQLHSTMT,SQLUSMALLINT,SQLWCHAR*,SQLSMALLINT,SQLWCHAR*,SQLSMALLINT,SQLWCHAR*,SQLSMALLINT,SQLUSMALLINT,SQLUSMALLINT->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLUSMALLINT,SQLWCHAR *,SQLSMALLINT,SQLWCHAR *,SQLSMALLINT,SQLWCHAR *,SQLSMALLINT,SQLUSMALLINT,SQLUSMALLINT))")
   (type SQLHSTMT,SQLWCHAR*,SQLSMALLINT,SQLWCHAR*,SQLSMALLINT,SQLWCHAR*,SQLSMALLINT,SQLUSMALLINT,SQLUSMALLINT->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLWCHAR *,SQLSMALLINT,SQLWCHAR *,SQLSMALLINT,SQLWCHAR *,SQLSMALLINT,SQLUSMALLINT,SQLUSMALLINT))")
   (type SQLHENV,SQLUSMALLINT,SQLWCHAR*,SQLSMALLINT,SQLSMALLINT*,SQLWCHAR*,SQLSMALLINT,SQLSMALLINT*->SQLRETURN "SQLRETURN ($(SQLHENV,SQLUSMALLINT,SQLWCHAR *,SQLSMALLINT,SQLSMALLINT *,SQLWCHAR *,SQLSMALLINT,SQLSMALLINT *))")
   (type SQLHDBC,SQLHWND,SQLWCHAR*,SQLSMALLINT,SQLWCHAR*,SQLSMALLINT,SQLSMALLINT*,SQLUSMALLINT->SQLRETURN "SQLRETURN ($(SQLHDBC,SQLHWND,SQLWCHAR *,SQLSMALLINT,SQLWCHAR *,SQLSMALLINT,SQLSMALLINT *,SQLUSMALLINT))")
   (type SQLHDBC,SQLWCHAR*,SQLSMALLINT,SQLWCHAR*,SQLSMALLINT,SQLSMALLINT*->SQLRETURN "SQLRETURN ($(SQLHDBC,SQLWCHAR *,SQLSMALLINT,SQLWCHAR *,SQLSMALLINT,SQLSMALLINT *))")
   (type SQLHSTMT,SQLWCHAR*,SQLSMALLINT,SQLWCHAR*,SQLSMALLINT,SQLWCHAR*,SQLSMALLINT,SQLWCHAR*,SQLSMALLINT,SQLWCHAR*,SQLSMALLINT,SQLWCHAR*,SQLSMALLINT->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLWCHAR *,SQLSMALLINT,SQLWCHAR *,SQLSMALLINT,SQLWCHAR *,SQLSMALLINT,SQLWCHAR *,SQLSMALLINT,SQLWCHAR *,SQLSMALLINT,SQLWCHAR *,SQLSMALLINT))")
   (type SQLHDBC,SQLWCHAR*,SQLINTEGER,SQLWCHAR*,SQLINTEGER,SQLINTEGER*->SQLRETURN "SQLRETURN ($(SQLHDBC,SQLWCHAR *,SQLINTEGER,SQLWCHAR *,SQLINTEGER,SQLINTEGER *))")
   (type SQLHSTMT,SQLWCHAR*,SQLSMALLINT,SQLWCHAR*,SQLSMALLINT,SQLWCHAR*,SQLSMALLINT->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLWCHAR *,SQLSMALLINT,SQLWCHAR *,SQLSMALLINT,SQLWCHAR *,SQLSMALLINT))")
   (type SQLHSTMT,SQLSMALLINT,SQLSMALLINT,SQLPOINTER,SQLSMALLINT,SQLSMALLINT*,SQLPOINTER->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLSMALLINT,SQLSMALLINT,SQLPOINTER,SQLSMALLINT,SQLSMALLINT *,SQLPOINTER))")
   (type SQLHSTMT,SQLUSMALLINT,SQLUINTEGER->SQLRETURN "SQLRETURN ($(SQLHSTMT,SQLUSMALLINT,SQLUINTEGER))")

   ))
