;; ***** BEGIN LICENSE BLOCK *****
;; Roadsend PHP Compiler Runtime Libraries
;; Copyright (C) 2007 Roadsend, Inc.
;;
;; This program is free software; you can redistribute it and/or
;; modify it under the terms of the GNU Lesser General Public License
;; as published by the Free Software Foundation; either version 2.1
;; of the License, or (at your option) any later version.
;; 
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU Lesser General Public License for more details.
;; 
;; You should have received a copy of the GNU Lesser General Public License
;; along with this program; if not, write to the Free Software
;; Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
;; ***** END LICENSE BLOCK *****

(module streams-c-bindings
   (extern
    (include "streams-c-bindings.h")
    (include "windows-flock.h")
    (type FILE* (opaque) "FILE *")
    (type int* (pointer int) "int *")
    (type fd_set* (opaque) "fd_set *")
    (type char** (pointer string) "char **")
    (type uchar* string "unsigned char *")
    (type pfl-uid_t uint "uid_t")
    (type pfl-gid_t uint "gid_t")
    (type pfl-time_t llong "time_t")
    (type pfl-dev_t llong "dev_t")
    (type pfl-mode_t uint "mode_t")
    (type pfl-nlink_t uint "nlink_t")
    (type pfl-off_t long "off_t")
    (type pfl-ino_t ulong "ino_t")
    (type pfl-const-str string "const char *")
    (type pfl-struct-timeval
	  (struct (tv_sec::elong "tv_sec")
		  (tv_usec::elong "tv_usec"))
	  "struct timeval")
;;mingw     (type pfl-struct-group
; 	  (struct (gr_name::string   "gr_name")
; 		  (gr_passwd::string "gr_passwd")
; 		  (gr_gid::pfl-gid_t "gr_gid")
; 		  (gr_mem::char**    "gr_mem"))
; 	  "struct group")
    (type pfl-struct-utimbuf
	  (struct (actime::pfl-time_t  "actime")
		  (modtime::pfl-time_t "modtime"))
	  "struct utimbuf")
;;mingw    (type pfl-struct-passwd
; 	  (struct (pw_name::string   "pw_name")
; 		  (pw_passwd::string "pw_passwd")
; 		  (pw_uid::pfl-uid_t "pw_uid")
; 		  (pw_gid::pfl-gid_t "pw_gid")
; 		  (pw_gecos::string  "pw_gecos")
; 		  (pw_dir::string    "pw_dir")
; 		  (pw_shell::string  "pw_shell"))
; 	  "struct passwd")
    (type net-hostent-struct
	  (struct (h_name::string      "h_name")
		  (h_aliases::char**   "h_aliases")
		  (h_addrtype::int     "h_addrtype")
		  (h_length::int       "h_length")
		  (h_addr_list::char** "h_addr_list"))
	  "struct hostent")
    (type net-inaddr-struct
	  (struct (s_addr::elong "s_addr"))
	  "struct in_addr")
    (type net-protoent-struct
	  (struct (p_name::string    "p_name")
		  (p_aliases::char** "p_aliases")
		  (p_proto::int      "p_proto"))
	  "struct protoent")
    (type net-servent-struct
	  (struct (s_name::string    "s_name")
		  (s_aliases::char** "s_aliases")
		  (s_port::int       "s_port")
		  (s_proto::string   "s_proto"))
	  "struct servent")
    (macro fcntl1::int (::int ::int) "fcntl")
    (macro fcntl2::int (::int ::int ::elong) "fcntl")
    (macro fileno::int (::FILE*) "fileno")
    ;; from c-files.c
    (c-php-fgets::obj (::FILE* ::int) "php_fgets")
    ;; from network.c
;    (php_fsockopen::int (::string ::int ::int ::int ::int* ::string) "php_fsockopen")
    (php_getmxrr::int (::string ::string ::string) "php_getmxrr")
    (php_checkdnsrr::int (::string ::string) "php_checkdnsrr")
    (php_getprotobyname::int (::string) "php_getprotobyname")
    (php_getservbyname::int (::string ::string) "php_getservbyname")
    (php_ip2long::long (::string) "php_ip2long")
    (init-winsock::int () "init_winsock")
    (cleanup-winsock::int () "cleanup_winsock")
    (my-fdopen::FILE* (::int ::string) "pcc_fdopen")
    (wait-for-data::int (::int ::int) "wait_for_data")
    (bigloo-recv::obj (fd::int maxlen::int) "bigloo_recv")
    (socket-read-returns-data::obj (fd::int) "bigloo_socket_read_returns_data")
    ;; end network.c
    (macro c-select::int (::int ::fd_set* ::fd_set* ::fd_set* ::pfl-struct-timeval*) "select")
    (fd_isset?::int (::fd_set* ::int) "fd_isset")
    (fd_set!::int (::fd_set* ::int) "fdset")
    (fd_zero!::int (::fd_set*) "fdzero")
    (macro net-fdopen::FILE* (::int ::string) "fdopen")
    (macro net-getservbyport::net-servent-struct* (::int ::string) "getservbyport")
    (macro net-htonl::elong (::elong) "htonl")
    (macro net-htons::int (::int) "htons")
    (macro net-getprotobynumber::net-protoent-struct* (::int) "getprotobynumber")
    (macro net-inet_pton::int (::int ::string ::string) "inet_pton")
    (macro net-gethostbyname::net-hostent-struct* (::string) "gethostbyname")
    (macro net-gethostbyaddr::net-hostent-struct* (::string ::int ::int) "gethostbyaddr")
;mingw    (macro net-openlog::void (::string ::int ::int) "openlog")
;mingw    (macro net-syslog::void (::int ::string) "syslog")
;mingw    (macro net-closelog::void () "closelog")
    (macro net-res_search::int (::string ::int ::int ::uchar* ::int) "res_search")
    (macro pfl-geteuid::pfl-uid_t () "geteuid")
    (macro pfl-getegid::pfl-uid_t () "getegid")
    (macro pfl-ftell::long (::FILE*) "ftell")
    (macro pfl-rewind::void (::FILE*) "rewind")
    (macro pfl-ftruncate::int (::int ::pfl-off_t) "ftruncate")
    (macro pfl-fseek::int (::FILE* ::int ::int) "fseek")
    (macro pfl-flock::int (::int ::int) "flock")
    (macro pfl-fclose::int (::FILE*) "fclose")
    (macro pfl-close::int (::int) "close")
    (macro pfl-fflush::int (::FILE*) "fflush")
    (macro pfl-fputs::int (::string ::FILE*) "fputs")
    (macro pfl-fwrite::int (data::string size::int nmemb::int stream::FILE*) "fwrite")
    (macro pfl-feof::int (::FILE*) "feof")
    (macro pfl-ferror::int (::FILE*) "ferror")
    (macro pfl-clearerr::void (::FILE*) "clearerr")
    (macro pfl-fgetc::int (::FILE*) "fgetc")
    (macro pfl-fread::int (ptr::string size::int nmemb::int stream::FILE*) "fread")
    (macro pfl-fileno::int (::FILE*) "fileno")
    (macro pfl-fopen::FILE* (::string ::string) "fopen")
    (macro pfl-popen::FILE* (::string ::string) "popen")
    (macro pfl-pclose::int (::FILE*) "pclose")
    (macro pfl-path-max::int "PATH_MAX")
    (macro pfl-realpath::string (::string ::string) "realpath")
    (macro pfl-symlink::int (::string ::string) "symlink")
    (macro pfl-link::int (::string ::string) "link")
    (macro pfl-umask::pfl-mode_t (::pfl-mode_t) "umask")
    (macro pfl-fnmatch::int (::string ::string ::int) "fnmatch")
;;mingw    (macro pfl-getpwnam::pfl-struct-passwd* (::string) "getpwnam")
    (macro pfl-utime::int (::string ::pfl-struct-utimbuf*) "utime")
;;mingw    (macro pfl-getgrnam::pfl-struct-group* (::string) "getgrnam")
    (macro pfl-chmod::int (::string ::pfl-mode_t) "chmod")
    (macro pfl-chown::int (::string ::pfl-uid_t ::pfl-gid_t) "chown")
    (macro PFL_SEEK_SET::int "SEEK_SET")
    (macro PFL_SEEK_CUR::int "SEEK_CUR")
    (macro PFL_SEEK_END::int "SEEK_END")
    (macro net-SOCK_STREAM::int "SOCK_STREAM")
    (macro net-SOCK_DGRAM::int  "SOCK_DGRAM")
    (macro net-AF_UNIX::int     "AF_UNIX")
    (macro net-AF_INET::int     "AF_INET")
    (macro net-C_IN::int        "C_IN")
    (macro net-T_MX::int        "T_MX")
    (macro net-MAXPACKET::int   "MAXPACKET")
    ;; openlog "options" constants
;mingw    (macro net-LOG_CONS::int   "LOG_CONS")
;mingw    (macro net-LOG_NDELAY::int "LOG_NDELAY")
;mingw    (macro net-LOG_ODELAY::int "LOG_ODELAY")
;mingw    (macro net-LOG_PERROR::int "LOG_PERROR")
;mingw    (macro net-LOG_PID::int    "LOG_PID")
;mingw    ;; openlog "facilities" constants
;mingw    (macro net-LOG_AUTH::int     "LOG_AUTH")
;mingw    (macro net-LOG_AUTHPRIV::int "LOG_AUTHPRIV")
;mingw    (macro net-LOG_CRON::int     "LOG_CRON")
;mingw    (macro net-LOG_DAEMON::int   "LOG_DAEMON")
;mingw    (macro net-LOG_KERN::int     "LOG_KERN")
;mingw    (macro net-LOG_LPR::int      "LOG_LPR")
;mingw    (macro net-LOG_MAIL::int     "LOG_MAIL")
;mingw    (macro net-LOG_NEWS::int     "LOG_NEWS")
;mingw    (macro net-LOG_SYSLOG::int   "LOG_SYSLOG")
;mingw    (macro net-LOG_USER::int     "LOG_USER")
;mingw    (macro net-LOG_UUCP::int     "LOG_UUCP")
;mingw    (macro net-LOG_LOCAL0::int   "LOG_LOCAL0")
;mingw    (macro net-LOG_LOCAL1::int   "LOG_LOCAL1")
;mingw    (macro net-LOG_LOCAL2::int   "LOG_LOCAL2")
;mingw    (macro net-LOG_LOCAL3::int   "LOG_LOCAL3")
;mingw    (macro net-LOG_LOCAL4::int   "LOG_LOCAL4")
;mingw    (macro net-LOG_LOCAL5::int   "LOG_LOCAL5")
;mingw    (macro net-LOG_LOCAL6::int   "LOG_LOCAL6")
;mingw    (macro net-LOG_LOCAL7::int   "LOG_LOCAL7")
;mingw    ;; syslog "priorities" constants
;mingw    (macro net-LOG_EMERG::int   "LOG_EMERG")
;mingw    (macro net-LOG_ALERT::int   "LOG_ALERT")
;mingw    (macro net-LOG_CRIT::int    "LOG_CRIT")
;mingw    (macro net-LOG_ERR::int     "LOG_ERR")
;mingw    (macro net-LOG_WARNING::int "LOG_WARNING")
;mingw    (macro net-LOG_NOTICE::int  "LOG_NOTICE")
;mingw    (macro net-LOG_INFO::int    "LOG_INFO")
;mingw    (macro net-LOG_DEBUG::int   "LOG_DEBUG")
;mingw    ;; fcntl constants
    (macro F_SETFL::int         "F_SETFL")
    (macro F_GETFL::int         "F_GETFL")
    ))
    